//#include<cpgplot.h>
#include "param.h"

#include<cmath>
#include"graph.h"
#include<iostream>
#include<vector>
#include <algorithm>
#include<numeric>
#include "Dal.h"
#include "utility.h"
#include "statistics.h"








/**************************************************
*
*
*
*************************************************/
void setFortranText(char *text)
{

  setParameter("plotfile", text);


}




int size = 513;

/********************************************************************
*
*
*********************************************************************/
void cbpglab(char *xlabel, char *ylabel, char *title )
{
  
 


    setParameter("plotfile", xlabel);

    F90MODPROC( pggraph_mod, setxlabel)();

  
    setParameter("plotfile", ylabel);

    F90MODPROC( pggraph_mod, setylabel)();


    setParameter("plotfile", title);

    F90MODPROC( pggraph_mod, settitle)();


    F90MODPROC( pggraph_mod, pglab1)();

}


/**************************************************************
*
*
***************************************************************/
void cbpgmtxt(const char *position, float x1, float x2, float x3, const char *label)
{

 
 

    setParameter("plotfile", position);

    F90MODPROC( pggraph_mod, settextposition)();


    setParameter("plotfile", label);

    F90MODPROC( pggraph_mod, setlabel)();



    F90MODPROC( pggraph_mod, pgmtxt1)(&x1, &x2, &x3);


}



/********************************************************************
*
*
*
*********************************************************************/
void cbpgpage()
{
    F90MODPROC( pggraph_mod, pgpage1)();

}


/********************************************************************
*
*
*
*********************************************************************/
void cbpgclos()
{
    F90MODPROC( pggraph_mod, pgclos1)();

}

/********************************************************************
*
*
*
*********************************************************************/
int cbpgopen(char *file)
{

    setParameter("plotfile", file);

    int k = F90MODPROC( pggraph_mod, pgopen1)();


    return k;
}




/********************************************************************
*
*
*********************************************************************/
void cbpgmove(float x, float y)
{
    F90MODPROC( pggraph_mod, pgmove1)(&x, &y);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgdraw(float x, float y)
{
    F90MODPROC( pggraph_mod, pgdraw1)(&x, &y);

}
/**************************************************************
*
*
**************************************************************/
float cbpgrnd( float binWidth, int nSub )
{




  //  int k = F90MODPROC( pggraph_mod, pgopen1)();

    float f = F90MODPROC( pggraph_mod, pgrnd1)(&binWidth, &nSub);
    return f;


}



/********************************************************************
*
*
*********************************************************************/
void cbpgsubp(int x, int y)
{
    F90MODPROC( pggraph_mod, pgsubp1)(&x, &y);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgpanl(int x, int y)
{
    F90MODPROC( pggraph_mod, pgpanl1)(&x, &y);

}





/********************************************************************
*
*
*********************************************************************/
void cbpgrnge(float x1, float y1, float *x2, float *y2)
{
    F90MODPROC( pggraph_mod, pgrnge1)(&x1, &y1, x2, y2);

}



/********************************************************************
*
*
*********************************************************************/
void cbpgsvp(float x1, float x2, float y1, float y2)
{
    F90MODPROC( pggraph_mod, pgsvp1)(&x1, &x2, &y1, &y2);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgswin(float x1, float x2, float y1, float y2)
{
    F90MODPROC( pggraph_mod, pgswin1)(&x1, &x2, &y1, &y2);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgrect(float x1, float x2, float y1, float y2)
{
    F90MODPROC( pggraph_mod, pgrect1)(&x1, &x2, &y1, &y2);

}







/********************************************************************
*
*
*********************************************************************/
void cbpgwnad(float x1, float x2, float y1, float y2)
{
    F90MODPROC( pggraph_mod, pgwnad1)(&x1, &x2, &y1, &y2);

}



/********************************************************************
*
*
*********************************************************************/
void cbpgscr(int x1, float x2, float y1, float y2)
{
    F90MODPROC( pggraph_mod, pgscr1)(&x1, &x2, &y1, &y2);

}








/********************************************************************
*
*
*********************************************************************/
void cbpgline(int nData, float *x, float *y)
{
    F90MODPROC( pggraph_mod, pgline1)(&nData, x, y);

}
/********************************************************************
*
*
*********************************************************************/
void cbpgpt(int nData, float *x, float *y, int symbol)
{
  

    F90MODPROC( pggraph_mod, pgpt11)(&nData, x, y, &symbol);

}
/********************************************************************
*
*
*********************************************************************/
void cbpgpt1(float x, float y, int symbol)
{
    F90MODPROC( pggraph_mod, pgpt111)(&x, &y, &symbol);

}




/********************************************************************
*
*
*********************************************************************/
void cbpgerr1(int k, float x, float y, float error, int k1)
{
    F90MODPROC( pggraph_mod, pgerr11)(&k, &x, &y, &error, &k1);

}


/********************************************************************
*
*
*********************************************************************/
void cbpgerrx(int nData, float *x, float *y, float *error, int k)
{
    F90MODPROC( pggraph_mod, pgerrx1)(&nData, x, y, error, &k);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgerry(int nData, float *x, float *y, float *error, int k)
{
    F90MODPROC( pggraph_mod, pgerry1)(&nData, x, y, error, &k);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgsch(float size)
{
    F90MODPROC( pggraph_mod, pgschi1)(&size);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgsls(int style)
{
    F90MODPROC( pggraph_mod, pgsls1)(&style);

}



/********************************************************************
*
*
*********************************************************************/
void cbpgslw(int width)
{
    F90MODPROC( pggraph_mod, pgslw1)(&width);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgsfs(int type)
{
    F90MODPROC( pggraph_mod, pgsfs1)(&type);

}


/********************************************************************
*
*
*********************************************************************/
void cbpgsci(int colour)
{
    F90MODPROC( pggraph_mod, pgsci1)(&colour);

}

/******************************************************************
*
*
*****************************************************************/
void cbpgbox(const char *xformat, float x, int k1, const char *yformat, float y, int k2)
{


    setParameter("plotfile", xformat);

    F90MODPROC( pggraph_mod, setxboxformat)();
    
  

    setParameter("plotfile", yformat);

    F90MODPROC( pggraph_mod, setyboxformat)();

 

    F90MODPROC( pggraph_mod, pgbox1)(&x, &k1, &y, &k2);




}

/********************************************************************
*
*
*
*
*********************************************************************/
void cbpghist(int nData, float *xData, float xmin, float xmax, int noBins, int type)
{
  F90MODPROC( pggraph_mod, pghist1)(&nData, xData, &xmin, &xmax, &noBins, &type);


  //        cpghist(nData, xData, (float)xmin, (float)xmax, noBins, 3);


			      
}











/*******************************************************
*
********************************************************/
bool histCompare10(const HistData &a, const HistData &b)
{
      return a.x < b.x;
};     






int symbol = 9;
int colour = 1;

int maxNoBins = 20;

void setMaxNoBins(int no)
{
  maxNoBins = no;
}



void setColour(int col)
{
  colour = col;
}

void setSymbol(int col)
{
  symbol = col;
}

int getColour() { return colour; };
int getSymbol() { return symbol; };
int getMaxNoBins() { return maxNoBins; };


/****************************************************************
*
*
*****************************************************************/

class alist
{
public:
    float x;
    float y;
public:
    alist(float a, float b) : x(a), y(b) {};
    alist(const alist &a)
    {
      x = a.x;
      y = a.y;
    }
    ~alist() {};



  bool  operator<(const alist &a) const 
  {

    cout << "alist sorting x=" << x << " a.x=" << a.x << endl;
    if (x < a.x) return true;
    if (x > a.x) return false;
    return true;

  };
};



struct aListSort
{

  bool operator()(alist*& a, alist*& b)
  {  
  if (a->x < b->x) return true;
  if (a->x > b->x) return false;
  return true;
  }


};




float HistogramMaximum(int maxFreq, int nData, float &yMax1);
float* TransformMatrix(float xmin, float xbinWidth, 
		       float ymin, float ybinWidth);



void loadDensity( float *a, int nx, int ny, 
                  float xmin, float xmax, 
                  float ymin, float ymax, 
                  vector<float> & xdata, vector<float> & ydata, int ndata);


//
void SetUpPalette(int type);

//void DrawColourScale(char side[], float disp, float width, char *label, 
//		     float foreGround, float backGround);




#include <f90cxx.h>




F90MODPROCPROTO( void, minimize_mod, minimum)(int *, double *, double *, double * , double *, double *);





/*******************************************************************
*
*******************************************************************/
void drawGraph( int ndata, 
                float* xdata, 
                float *xerrors, 
                float *ydata, 
                float *yerrors,
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2,
                float y1, 
                float y2,             
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes)
  
{
    
    float *lower = 0, *upper = 0;
    float xmin, xmax, ymin, ymax;
  
       
    xmin =  10000.0;
    xmax = -10000.0;
    ymin = xmin;
    ymax = xmax;
             
    for (int j = 0; j <  ndata; j++)
    {
        
        if (xdata[j] < xmin) xmin = xdata[j];
        if (xdata[j] >  xmax) xmax = xdata[j];
        if (ydata[j] < ymin) ymin = ydata[j];
        if (ydata[j] > ymax) ymax = ydata[j];
    }
				  
    if (fabs(ymax - ymin) < 1e-10) 
    {
        ymin = ymin - 0.1;
        ymax = ymax + 0.1;
    }    

    cbpgsci( 1 );
    cbpgsvp(x1, x2, y1, y2);

     
    cbpgrnge(xmin, xmax, &xmin, &xmax);
    cbpgrnge(ymin, ymax, &ymin, &ymax);



    if ( fabs(xmin1 - xmax1) > 1e-6) 
    {
        xmin = xmin1;
        xmax = xmax1;
    }
  
    if ( fabs(ymin1 - ymax1) > 1e-6) 
    {
        ymin = ymin1;
        ymax = ymax1;
    }
  



    
    if (equalAxes)
    { 
	 cbpgwnad(xmin, xmax, ymin, ymax);
    }
    else
    {
        cbpgswin(xmin, xmax, ymin, ymax);
        
    }
    cbpgsch(1.0);
      
  
    cbpgsls(1);
    cbpgbox((char *)"bctsi", 0.0, 0, (char *)"bctsi", 0.0, 0);
    cbpgsch(1.0);
    cbpgslw(1);
    cbpgbox((char *)"n", 0.0, 0, (char *)"n", 0.0, 0);
   





    cbpgsch(1.0); 
    cbpgslw(3);
    cbpglab((char *)"", ylabel, title);
    cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xlabel );
  

    cbpgslw(1);
  
    cbpgsch(0.6);
    cbpgsci(colour);        
    cbpgpt(ndata, xdata, ydata, symbol);
    cbpgsci(1);

       
    lower = new float[ndata];
    upper = new float[ndata];
    
    for (int i = 0; i < ndata; i++)
    { 
        lower[i] = xdata[i] - xerrors[i];
        upper[i] = xdata[i] + xerrors[i];
    }       
    cbpgerrx(ndata, lower, upper, ydata, 0);
          

    for (int i = 0; i < ndata; i++)
    { 
        lower[i] = ydata[i] - yerrors[i];
        upper[i] = ydata[i] + yerrors[i];
    }       

           
    cbpgerry(ndata, xdata, lower, upper, 0);
    delete [] lower;
    delete [] upper;  

    cbpgslw(1);
    cbpgsch(0.5);
 
}













/****************************************************************
*
*
*****************************************************************/
void drawGraph( int ndata, 
                float* xdata, 
                float *ydata, 
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2, 
                float y1, 
                float y2, 
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes)
  
{
    

  //  cout << "Drawgraph line 657 xmin1=" << xmin1 << " xmax1=" << xmax1 << " ymin1=" << ymin1 << " ymax1=" << ymax1 << endl;
  
       
    float xmin =  10000.0;
    float xmax = -10000.0;
    float ymin = xmin;
    float ymax = xmax;
             
    for (int j = 0; j <  ndata; j++)
    {
        
        if (xdata[j] < xmin) xmin = xdata[j];
        if (xdata[j] > xmax) xmax = xdata[j];
        if (ydata[j] < ymin) ymin = ydata[j];
        if (ydata[j] > ymax) ymax = ydata[j];
    }
				  
    if (fabs(ymax - ymin) < 1e-10) 
    {
        ymin = ymin - 0.1;
        ymax = ymax + 0.1;
    }    

    cbpgsci( 1 );
    cbpgsvp(x1, x2, y1, y2);

     
    cbpgrnge(xmin, xmax, &xmin, &xmax);
    cbpgrnge(ymin, ymax, &ymin, &ymax);



    if ( fabs(xmin1 - xmax1) > 1e-6) 
    {
        xmin = xmin1;
        xmax = xmax1;
    }
  
    if ( fabs(ymin1 - ymax1) > 1e-6) 
    {
        ymin = ymin1;
        ymax = ymax1;
    }
  

    //    cout << "draw graph xmin1=" << xmin1 << " xmax1=" << xmax1 << " ymin1=" << ymin1 << " ymax1=" << ymax1 << endl;
    //  cout << "draw graph xmin=" << xmin << " xmax=" << xmax << " ymin=" << ymin << " ymax=" << ymax << endl;



    
    if (equalAxes)
    { 
	 cbpgwnad(xmin, xmax, ymin, ymax);
    }
    else
    {
        cbpgswin(xmin, xmax, ymin, ymax);
        
    }
    cbpgsch(1.0);
      
  
    cbpgsls(1);
    cbpgbox((char *)"bctsi", 0.0, 0, (char *)"bctsi", 0.0, 0);
    cbpgsch(1.0);
    cbpgslw(1);
    cbpgbox((char *)"n", 0.0, 0, (char *)"n", 0.0, 0);
   





    cbpgsch(1.0); 
    cbpgslw(3);
    cbpglab((char *)"", ylabel, title);
    cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xlabel );
  

    cbpgslw(1);
  
    cbpgsch(0.6);  
    cbpgsci(colour);        
    cbpgpt(ndata, xdata, ydata, symbol);
    cbpgsci(1);



        
 
   


    cbpgslw(1);
    cbpgsch(0.5);
 
}











/****************************************************************
*
*
*****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata, 
                char *xlabel, 
                char *ylabel, 
                char *title,                 
                vector<string> &subTitle,            
                float x1, 
                float x2,
                float y1,
                float y2,  
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1) 
               
  
{
    
    

       
    float xmin =  1000000000.0;
    float xmax = -1000000000.0;
    float ymin =  1000000000.0;
    float ymax = -1000000000.0;


    //    cout << "drawgraph line 334\n";


    for (int i = 0; i < ngraphs; i++)             
    {
      //    cout << "daya for graph " << i << endl;
        for (unsigned j = 0; j <  xdata[i].size(); j++)
        {
        
            if (xdata[i][j] < xmin) xmin = xdata[i][j];
            if (xdata[i][j] >  xmax) xmax = xdata[i][j];
            if (ydata[i][j] < ymin) ymin = ydata[i][j];
            if (ydata[i][j] >  ymax) ymax = ydata[i][j];
	    //            cout << j << " x=" << xdata[i][j] << " y=" << ydata[i][j] << endl;


        }
    }				  

    //    cout << "Line 352 xmin=" << xmin << " xmax=" << xmax << " ymin=" << ymin << " ymax=" << ymax << endl;


    cbpgrnge(xmin, xmax, &xmin, &xmax);





 

    if ( fabs(xmin1 - xmax1) > 1e-6) 
    {
        xmin = xmin1;
        xmax = xmax1;
    }

  
    if ( fabs(ymin1 - ymax1) > 1e-6) 
    {
        ymin = ymin1;
        ymax = ymax1;
    }

  


    //   cout << "Line 379 xmin=" << xmin << " xmax=" << xmax << " ymin=" << ymin << " ymax=" << ymax << endl;




    // cout << "graph.cc line 380 title=" << title << endl;
    // cout << "ylabel=" << ylabel << endl;

    // cout << "x1=" << x1 << " x2=" << x2 << " y1=" << y1 << " y2=" << y2 << endl;
    // cout << "xmin=" << xmin << " xmax=" << xmax << " ymin=" << ymin << " ymax=" << ymax << endl;


    cbpgsvp(x1, x2, y1, y2);

    cbpgswin(xmin, xmax, ymin, ymax);


    
    cbpgbox((char *)"bctsi", 0.0, 0, (char *)"bctsi", 0.0, 0);
    cbpgbox((char *)"n", 0.0, 0, (char *)"n", 0.0, 0);
    cbpgsch(1.0); 
    cbpgslw(3);
    cbpglab((char *)"", ylabel, (char *)"");
    cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xlabel ); 
    cbpgmtxt((char *)"T", 1.0, 0.5, 0.5, title );


    
    for (int i = 0; i < ngraphs; i++)                 
    {

        int nData = xdata[i].size();           

        if (nData == 0) continue;
	//	cout << "Line 407 drawing graph " << i << endl;
         

        cbpgsci(i + 1); 
     

        cbpgsls(1);


      
        cbpgslw(1);
  

        cbpgsch(0.7);
      
        cbpgmtxt((char *)"T", -(i + 1), 0.0, 0.0, subTitle[i].c_str());
  
    
        cbpgslw(1);
             
        cbpgsch(0.6);
    

	//	cout << "drawing graph " << i << " ndata=" << nData << endl;

        float *x = new float[nData];
        float *y = new float[nData];

        for (int j = 0; j < nData; j++)
	{
	    x[j] = xdata[i][j];
            y[j] = ydata[i][j];
	

        }

        cbpgsci(colour);        
        cbpgpt(nData, x, y, symbol);
        cbpgsci(1);


   

        delete [] x;
        delete [] y;

        cbpgslw(1);
        cbpgsch(0.5);

        cbpgsci(1);
    }  // End of this plot


 
  
}







/****************************************************************
 *
 *
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata, 
                vector<string> &subTitle, 
                char *xlabel, 
                char *ylabel, 
                char *title, 
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes,
                float dw1)
  
{
    
    
  
    float y1 = 0.1;  
       
    float xmin =  10000.0;
    float xmax = -10000.0;
    float dw = dw1;

    for (int i = 0; i < ngraphs; i++)             
    {
        for (unsigned j = 0; j <  xdata[i].size(); j++)
        {
        
            if (xdata[i][j] < xmin) xmin = xdata[i][j];
            if (xdata[i][j] >  xmax) xmax = xdata[i][j];
         
        }
    }				  

    cbpgrnge(xmin, xmax, &xmin, &xmax);

 

    if ( fabs(xmin1 - xmax1) > 1e-6) 
    {
        xmin = xmin1;
        xmax = xmax1;
    }

  



    
    int k = 1;
    for (int i = 0; i < ngraphs; i++)                 
    {
        cbpgsci(1); 
     

        float ymin = 100000.0;
        float ymax = -ymin;



        for (unsigned j = 0; j <  ydata[i].size(); j++)
        {
        
            if (ydata[i][j] < ymin) ymin = ydata[i][j];
            if (ydata[i][j] > ymax) ymax = ydata[i][j];
         
        }
    				  


        if (fabs(ymax - ymin) < 1e-10) 
        {
            ymin = ymin - 0.1;
            ymax = ymax + 0.1;
        }    


  
        if ( fabs(ymin1 - ymax1) > 1e-6) 
        {
            ymin = ymin1;
            ymax = ymax1;
        }
  

  
        float y11 = y1 + float(k - 1) * dw;
        float y22 = y1 + float(k) * dw;

        if (y22 > 0.9)
	{
	    k = 1;
            y11 = y1;
            y22 = y1 + dw;


            cbpgsch(0.8);
            cbpgmtxt((char *)"T", 1, 0.5, 0.5, title);
 

            cbpgpage();
        }
        
	k++;
    

	//        cout << "Line 371 x1=" << x1 << " x2=" << x2 << " y11=" << y11 << " y22=" << y22 << endl;

        cbpgsvp(x1, x2, y11, y22);

      
     
      
        if (equalAxes)
        { 
	    cbpgwnad(xmin, xmax, ymin, ymax);
        }
        else
        {
            cbpgswin(xmin, xmax, ymin, ymax);
        
        }

      
  
        cbpgsls(1);


        cbpgsch(1.0);
        cbpgslw(1);
  

        if (k == 2)
	{
         
            cbpgbox((char *)"bctsi", 0.0, 0, (char *)"bctsi", 0.0, 0);
            cbpgbox((char *)"n", 0.0, 0, (char *)"n", 0.0, 0);
            cbpgsch(1.0); 
            cbpgslw(3);
            cbpglab((char *)"", ylabel, (char *)"");
            cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xlabel );

        }
   
        else
	{

            cbpgbox((char *)"bctsi", 0.0, 0, (char *)"bctsi", 0.0, 0);       
            cbpgbox((char *)"", 0.0, 0, (char *)"n", 0.0, 0);
            cbpgsch(1.0); 
            cbpgslw(3);
            cbpglab((char *)"", ylabel, (char *)"");
          

        }  
        cbpgslw(1);
    

        cbpgsch(0.9);
      
        cbpgmtxt((char *)"T", -1, 0.5, 0.5, subTitle[i].c_str());
  
    

        cbpgslw(1);
  
           
        cbpgsch(0.6);
        int nData = xdata[i].size();           
        float *x = new float[nData];
        float *y = new float[nData];

        for (int j = 0; j < nData; j++)
	{
	    x[j] = xdata[i][j];
            y[j] = ydata[i][j];
	

        }

                  
        cbpgpt(nData, x, y, symbol);
   


   

        delete [] x;
        delete [] y;

        cbpgslw(1);
        cbpgsch(0.5);

        cbpgsci(1);
    }  // End of this plot


    cbpgsch(0.8);
    cbpgmtxt((char *)"T", 1, 0.5, 0.5, title);
  
}


/****************************************************************
 *
 *
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata,  
                void (*Action)(vector<float> &x, vector<float> &y, void * data),
                vector<void *> &data, 
                vector<string> &subTitle, 
                char *xlabel, 
                char *ylabel, 
                char *title, 
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes,
                float dw1)
  
{
    

  
    float y1 = 0.1;  
       
    float xmin =  10000.0;
    float xmax = -10000.0;
    float dw = dw1;

    for (int i = 0; i < ngraphs; i++)             
    {
        for (unsigned j = 0; j <  xdata[i].size(); j++)
        {
        
            if (xdata[i][j] < xmin) xmin = xdata[i][j];
            if (xdata[i][j] >  xmax) xmax = xdata[i][j];
         
        }
    }				  

    cbpgrnge(xmin, xmax, &xmin, &xmax);

 

    if ( fabs(xmin1 - xmax1) > 1e-6) 
    {
        xmin = xmin1;
        xmax = xmax1;
    }

  



    
    int k = 1;
    for (int i = 0; i < ngraphs; i++)                 
    {

    
        cbpgsci(1); 
     

        float ymin = 100000.0;
        float ymax = -ymin;



        for (unsigned j = 0; j <  ydata[i].size(); j++)
        {
        
            if (ydata[i][j] < ymin) ymin = ydata[i][j];
            if (ydata[i][j] > ymax) ymax = ydata[i][j];
         
        }
    				  
   
  

        if (fabs(ymax - ymin) < 1e-10) 
        {
            ymin = ymin - 0.1;
            ymax = ymax + 0.1;
        }    


  
        if ( fabs(ymin1 - ymax1) > 1e-6) 
        {
            ymin = ymin1;
            ymax = ymax1;
        }
  

  
        float y11 = y1 + float(k - 1) * dw;
        float y22 = y1 + float(k) * dw;



  
  


        if (y22 > 0.9)
	{
	    k = 1;
            y11 = y1;
            y22 = y1 + dw;


            cbpgsch(0.8);
            cbpgmtxt("T", 1, 0.5, 0.5, title);
 

            cbpgpage();
        }
        
	k++;
    

	//        cout << "Line 371 x1=" << x1 << " x2=" << x2 << " y11=" << y11 << " y22=" << y22 << endl;

        cbpgsvp(x1, x2, y11, y22);

      
     
      
        if (equalAxes)
        { 
	    cbpgwnad(xmin, xmax, ymin, ymax);
        }
        else
        {
            cbpgswin(xmin, xmax, ymin, ymax);
        
        }

      
  
        cbpgsls(1);


        cbpgsch(1.0);
        cbpgslw(1);
  

        if (k == 2)
	{
         
            cbpgbox((char *)"bctsi", 0.0, 0, (char *)"bctsi", 0.0, 0);
            cbpgbox((char *)"n", 0.0, 0, (char *)"n", 0.0, 0);
            cbpgsch(1.0); 
            cbpgslw(3);
            cbpglab((char *)"", ylabel, (char *)"");
            cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xlabel );

        }
   
        else
	{

            cbpgbox((char *)"bctsi", 0.0, 0, (char *)"bctsi", 0.0, 0);       
            cbpgbox((char *)"", 0.0, 0, (char *)"n", 0.0, 0);
            cbpgsch(1.0); 
            cbpgslw(3);
            cbpglab((char *)"", ylabel, (char *)"");
          

        }  
        cbpgslw(1);
    

        cbpgsch(0.9);
      
        cbpgmtxt((char *)"T", -1, 0.5, 0.5, subTitle[i].c_str());
  
    

        cbpgslw(1);
  





  
           
        cbpgsch(0.6);
        int nData = xdata[i].size();           
        float *x = new float[nData];
        float *y = new float[nData];

        for (int j = 0; j < nData; j++)
	{
	    x[j] = xdata[i][j];
            y[j] = ydata[i][j];
	

        }

        cbpgpt(nData, x, y, 9);


   cout << "Line 1468 i=" << i << endl;
  

        /**************************************************
	*
        **************************************************/
	cout << "graph.cc line 1457 calling action\n";

        if (Action)
	{
	  if (data[i])
	  {
            cout << "Line 1462 i=" << i << endl; 
            Action(xdata[i], ydata[i], data[i]);
            cout << "Line 1464 ngraphs=" << ngraphs << endl;
          }
        } 

	cout << "Line 1469\n";  
        delete [] x;
        delete [] y;

        cbpgslw(1);
        cbpgsch(0.5);


	cout << "Line 1477\n";  
 
        cbpgsci(1);
    }  // End of this plot


    cbpgsch(0.8);
    cbpgmtxt((char *)"T", 1, 0.5, 0.5, title);
  

	cout << "Line 1487\n";  
 
}






/****************************************************************
 *
 *
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata, 
                vector< vector<float> > &bin,             
                vector< vector<float> > &median, 
                vector< vector<float> > &lower, 
                vector< vector<float> > &upper, 

                vector<string> &subTitle, 
                char *xlabel, 
                char *ylabel, 
                char *title, 
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes,
                float dw1)
  
{
    
    
  
    float y1 = 0.1;  
       
    float xmin =  10000.0;
    float xmax = -10000.0;
    float dw = dw1;

    for (int i = 0; i < ngraphs; i++)             
    {
        for (unsigned j = 0; j <  xdata[i].size(); j++)
        {
        
            if (xdata[i][j] < xmin) xmin = xdata[i][j];
            if (xdata[i][j] >  xmax) xmax = xdata[i][j];
         
        }
    }				  

    cbpgrnge(xmin, xmax, &xmin, &xmax);

 

    if ( fabs(xmin1 - xmax1) > 1e-6) 
    {
        xmin = xmin1;
        xmax = xmax1;
    }

  



    
    int k = 1;
    for (int i = 0; i < ngraphs; i++)                 
    {
        cbpgsci(1); 
     

        float ymin = 100000.0;
        float ymax = -ymin;



        for (unsigned j = 0; j <  ydata[i].size(); j++)
        {
        
            if (ydata[i][j] < ymin) ymin = ydata[i][j];
            if (ydata[i][j] > ymax) ymax = ydata[i][j];
         
        }
    				  


        if (fabs(ymax - ymin) < 1e-10) 
        {
            ymin = ymin - 0.1;
            ymax = ymax + 0.1;
        }    


  
        if ( fabs(ymin1 - ymax1) > 1e-6) 
        {
            ymin = ymin1;
            ymax = ymax1;
        }
  

  
        float y11 = y1 + float(k - 1) * dw;
        float y22 = y1 + float(k) * dw;

        if (y22 > 0.9)
	{
	    k = 1;
            y11 = y1;
            y22 = y1 + dw;


            cbpgsch(0.8);
            cbpgmtxt((char *)"T", 1, 0.5, 0.5, title);
 

            cbpgpage();
        }
        
	k++;
    

	//        cout << "Line 371 x1=" << x1 << " x2=" << x2 << " y11=" << y11 << " y22=" << y22 << endl;

        cbpgsvp(x1, x2, y11, y22);

      
     
      
        if (equalAxes)
        { 
	    cbpgwnad(xmin, xmax, ymin, ymax);
        }
        else
        {
            cbpgswin(xmin, xmax, ymin, ymax);
        
        }

      
  
        cbpgsls(1);


        cbpgsch(1.0);
        cbpgslw(1);
  

        if (k == 2)
	{
         
            cbpgbox((char *)"bctsi", 0.0, 0, (char *)"bctsi", 0.0, 0);
            cbpgbox((char *)"n", 0.0, 0, (char *)"n", 0.0, 0);
            cbpgsch(1.0); 
            cbpgslw(3);
            cbpglab((char *)"", ylabel, (char *)"");
            cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xlabel );

        }
   
        else
	{

            cbpgbox((char *)"bctsi", 0.0, 0, (char *)"bctsi", 0.0, 0);       
            cbpgbox((char *)"", 0.0, 0, (char *)"n", 0.0, 0);
            cbpgsch(1.0); 
            cbpgslw(3);
            cbpglab((char *)"", ylabel, (char *)"");
          

        }  

        cbpgslw(1);

        cbpgsch(0.9);
      
        cbpgmtxt((char *)"T", -1, 0.5, 0.5, subTitle[i].c_str());
  
    
        cbpgslw(1);
  
           
        cbpgsch(0.6);
        int nData = xdata[i].size();           
        float *x = new float[nData];
        float *y = new float[nData];

        for (int j = 0; j < nData; j++)
	{
	    x[j] = xdata[i][j];
            y[j] = ydata[i][j];
	

        }

        cbpgpt(nData, x, y, 9);
   
        nData = bin[i].size();
	for (int j = 0; j < nData; j++)
	{

            x[j] = bin[i][j];
            y[j] = median[i][j];
	
        }
        cbpgsci(2);
        cbpgline(nData, x, y);

	for (int j = 0; j < nData; j++)
	{

            y[j] = lower[i][j];
	
        }
        cbpgsci(3);
        cbpgline(nData, x, y);


	for (int j = 0; j < nData; j++)
	{

            y[j] = upper[i][j];
	
        }
     
        cbpgline(nData, x, y);






        delete [] x;
        delete [] y;

        cbpgslw(1);
        cbpgsch(0.5);

        cbpgsci(1);
    }  // End of this plot


    cbpgsch(0.8);
    cbpgmtxt((char *)"T", 1, 0.5, 0.5, title);
  
}




/*****************************************************
* Subroutine Histogram
*
******************************************************/
void Histogram( int ndata, float *xBin, float *data, 
                 char *yLabel, char *xLabel, char *title, 
                 float x1, float x2, float y1, float y2, 
                 float xmin, float xmax, float yMax)
{
    
         
    if (fabs(xmin - xmax) < 1e-6) {
        cout << "Unable to draw histogram- xmin=xmax\n";
        return;
    }

   


  
    

    /******************************
     * Find the maximum bin size
     ******************************/

    if( yMax < 0.0)
    {
        yMax = 0.0;
        for (int i = 0; i < ndata; i++) 
        {
            yMax = max(yMax, data[i]);  
       
        }
    
        yMax = ceil(yMax * 10000.0) / 10000.0; 
    }
    
     
    cbpgsvp(x1, x2, y1, y2);

    cbpgswin(xmin, xmax, 0.0, yMax);
         

    cbpgsci(1);     
    cbpgsch(1.0); 
    cbpgsfs(2);    
    cbpgslw(1);    


    

    //    cbpgbin(ndata, xBin, data, true );


    float binWidth =  (xmax - xmin) / (float)ndata; 

   
    for(int i = 0; i < ndata; i++)
    {
        float x1 = xBin[i] - binWidth / 2.0;
        float x2 = xBin[i] + binWidth / 2.0;


        cbpgsfs(2);
        cbpgrect(x1, x2, 0.0, data[i]);



        cbpgsfs(3);

        cbpgrect(x1, x2, 0.0, data[i]);

        


    }
  
    cbpgsch(1.0);  
    if(ndata > 20) binWidth =  (xmax - xmin) / 20.0; 
    
   
    
    cbpgbox((char *)"bctsi", binWidth, 5, (char *)"bctsi", 0.0, 0);

    cbpgsch(1.0);  
    cbpgbox((char *)"n", binWidth, 5, (char *)"n", 0.0, 0); 
  
  
 
    cbpgsch(1.0);

    cbpgslw(3);
       
    cbpglab((char *)"", yLabel, title);
    
    cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xLabel);
    cbpgslw(1);
 
}



/*****************************************************
* Subroutine Histogram
*
******************************************************/
void Histogram( int ndata, int nBins, float *xBin, float **data, 
                 char *yLabel, char *xLabel, char *title, 
                 float x1, float x2, float y1, float y2, 
                 float xmin, float xmax, float yMax)
{
    
         
    if (fabs(xmin - xmax) < 1e-6) {
        cout << "Unable to draw histogram- xmin=xmax\n";
        return;
    }

   


    

    /******************************
    * Find the maximum bin size
    ******************************/
    cout << "Line 1856\n";
    if( yMax < 0.0)
    {
        yMax = 0.0;
        for(int j = 0; j < nBins; j++)
            for (int i = 0; i < ndata; i++) 
            {
                yMax = max(yMax, data[i][j]);  
       
            }
    
            yMax = ceil(yMax * 10000.0) / 10000.0; 
    }
    
     
    cbpgsvp(x1, x2, y1, y2);

    cbpgswin(xmin, xmax, 0.0, yMax);
         

    cbpgsci(1);     
    cbpgsch(1.0); 
    cbpgsfs(2);    
    cbpgslw(1);    


    

   cout << "Line 1884\n";


    float binWidth =  (xmax - xmin) / (float)nBins; 






    cout << "ndata=" << ndata << " nbins=" << nBins << endl;
   
    /*****************************************************************
    *
    ******************************************************************/
    for(int i = 0; i < nBins; i++)  // The number o bins
    {

     
        float dx = binWidth * 0.25 / (float)ndata;


        vector<float> binY;
        for(int j = 0; j < ndata; ++j)  // The number of bins (same for each data set)
	    binY.push_back( data[j][i]);
 


      
      
        sort(binY.begin(), binY.end() );
        float y1 = 0.0;
        for(int k = 0, j = ndata - 1; j >= 0; --j, ++k)
	{    
	

            float x1 = xBin[i] - binWidth / 2.0 + dx * (float)k;
            float x2 = xBin[i] + binWidth / 2.0 - dx * (float)k;
 

    
	    cbpgsci(j + 1);
	    float y2 = binY[j];
	    //           cpgsfs(3);

	    //            cpgrect(x1, x2, y1, y2);

            cbpgsfs(2);
            cbpgrect(x1, x2, 0.0, y2);
            y1 = y2;
        }

    }
    cbpgsci(1);
    cbpgsch(1.0);  
    if(nBins > 20) binWidth =  (xmax - xmin) / 20.0; 
    
   
    
    cbpgbox((char *)"bctsi", binWidth, 5, (char *)"bctsi", 0.0, 0);

    cbpgsch(1.0);  
    cbpgbox((char *)"n", binWidth, 5, (char *)"n", 0.0, 0); 
  
  
 
    cbpgsch(1.0);

    cbpgslw(3);
 
       
    cbpglab((char *)"", yLabel, title);
    
    cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xLabel);
    cbpgslw(1);
 

}





/*****************************************************
* Subroutine Histogram
*
******************************************************/
void Histogram( int ndata, float *data, float binWidth, 
                 char *xLabel, char *title, 
                 float x1, float x2, float y1, float y2, 
                 float xmin, float xmax)
{
             
    if (fabs(xmin - xmax) < 1e-6) {
        cout << "Unable to draw histogram- xmin=xmax\n";
        return;
    }

   

 
    int noBins = int( (xmax - xmin) / binWidth + 0.0001 );

    if (noBins < 3) {
        cout << "omgraph- No of bins < 3\n";
        return;
    }
  
    

    /******************************
     * Find the maximum bin size
     *******************************/

    int *frequency = new int[noBins];
    for (int i = 0; i < noBins; i++)
        frequency[i] = 0;




    int noLeft = 0, noRight = 0;

    for (int i = 0; i < ndata; i++) 
    {
        int k = int((data[i] - xmin) / binWidth + 0.00000001);       
        if (k < 0)
	{
	    noLeft++;
            k = 0;
        }
        else if (k >= noBins)
	{
	    noRight++;
            k = noBins - 1;
        }
        frequency[k]++;
       
    }
    
    float  yMax = int( float( MaxVal(frequency, noBins)) * 1.50); 

    delete [] frequency;  
     
    cbpgsvp(x1, x2, y1, y2);

    cbpgswin(xmin, xmax, 0.0, yMax);
         

    cbpgsci(1);     
    cbpgsch(1.0); 
    cbpgsfs(2);    
    cbpgslw(1);    
    cbpghist(ndata, data, xmin, xmax, noBins, 3);

    cbpgswin(xmin, xmax, 0.0, (yMax / float(ndata)) * 100.0);
  

    cbpgsch(1.0);  
 
    if(noBins > 20.0) binWidth *= 2.0;
    
    cbpgbox((char *)"bctsi", binWidth, 5, (char *)"bctsi", 0.0, 0);

    cbpgsch(1.0);  
    cbpgbox((char *)"n", binWidth, 5, (char *)"n", 0.0, 0); 
  
    char text[100];
    int k = 1;
    if (noLeft > 0)
    {
        sprintf( text, "No of data points < %.2f=%d", xmin, noLeft);        
        cbpgmtxt((char *)"T", -float(k), 0.0, 0.0, text);
        k++;
    }

    if (noRight> 0)
    {
        sprintf( text, "No of data points > %.2f=%d", xmax, noRight);        
        cbpgmtxt((char *)"T", -float(k), 0.0, 0.0, text);
        k++;
    }



    cbpgsch(1.0);

    char yLabel[100];

    sprintf( yLabel, "%s, %d %s", "FREQUENCY (%) (TOTAL=", ndata, ")" );
       
    cbpgslw(3);
 

    cbpglab((char *)"", yLabel, title);
    
    cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xLabel);
    cbpgslw(1);
 

}





/********************************************************************
*
*
********************************************************************/
float HistogramMaximum(int maxFreq, int nData, float &yMax1)
{
    float yMax = 5.0 + 100.0 * (float)maxFreq / (float)nData; 



    if (yMax >= 90.0)
        yMax = 100.0;
    else if (yMax >= 80.0)
        yMax = 90.0;
    else if (yMax >= 70.0)
        yMax = 80.0;
    else if (yMax >= 60.0)
        yMax = 70.0;
    else if (yMax >= 50.0)
        yMax = 60.0;
    else if (yMax >= 45.0)
        yMax = 50.0;  
    else if (yMax >= 40.0)
        yMax = 45.0;
    else if (yMax >= 35.0)
        yMax = 40.0;  
    else if (yMax >= 30.0)
        yMax = 35.0;
    else if (yMax >= 25.0)
        yMax = 30.0;
    else if (yMax >= 20.0)
        yMax = 25.0;
    else if (yMax >= 15.0)
        yMax = 20.0;
    else if (yMax >= 10.0)
        yMax = 15.0;
 
    else
        yMax = 10.0;


    yMax1 = yMax * nData / 100.0; 
    return yMax;
}

/*********************************************************************
*
*
**********************************************************************/
void binnedData(vector<float>  &xData, 
                vector<float>  &yData,
                float xMin, 
                float xMax, 
                float dx,
                vector<float>  &bins,
                vector<float>  &median,
                vector<float>  &lower,
                vector<float>  &upper)
{

    bins.clear();
    lower.clear();
    upper.clear();
    median.clear();
 
 
    cout << "graph.cc line 2721\n";
    unsigned long n = xData.size();
    
    int noBins = (int) ( (xMax - xMin) / dx + 0.0001);

  


    if (noBins < 5) return;


    vector<float> x;
    vector<alist> theList;

    for (int i = 0; i < noBins; i++)
    {
    
      
        float xl = xMin + float(i) * dx;
        float xu = xMin + float(i + 1) * dx;
    
       
     
   
  

      

        for (unsigned long j = 0; j <  n; j++)
	{
	  
   
	    if ( xData[j] > xl && xData[j] <= xu)
	    { 
                alist a( xData[j], yData[j]);
           
		theList.push_back( a );
            }
 
        }

	  
   
        if (theList.size() > 49)
	{



	  //	   sort( theList.begin(), theList.end());
	  
        

	   for (unsigned k = 0; k < theList.size(); k++)
	       x.push_back(theList[k].x);


	   bins.push_back( (xl + xu) / 2.0 );
	



            x.clear();
           
    

	    for (unsigned k = 0; k < theList.size(); k++)
	        x.push_back(theList[k].y);


  	

            sort(x.begin(), x.end());

	    median.push_back( Median(x) );
   
     
            lower.push_back( Percentile(x, 0.05));
       
	 

	    upper.push_back( Percentile(x, 0.95));
            x.clear();

        }
        theList.clear();
     
      

    } 

   
    cout << "Line 2819 leaving binneddata \n";

}
/*******************************************************
*
*******************************************************/   
void action1(vector<float> &xData, vector<float> &yData, void *data1)
{
 
  cout << "graph.cc action1 line 2813\n";

    if ( data1 == 0) return;

    cout << "graph.cc action1 line 2834 xdata.size=" << xData.size() << endl;


    if (xData.size() < 100) 
    { 
      cout << "Line 2835 returning\n";
        return;
    }
  cout << "graph.cc action1 line 2838\n";


    BinData *data = (BinData *)data1;
    
  cout << "graph.cc action1 line 2844\n";



    vector<float>  bin, median, lower, upper;

  cout << "graph.cc action1 line 2824\n";

 


    binnedData(xData, yData, data->xMin, data->xMax, data->dx, bin, median, lower, upper); 



   
 
   int nData = (int)bin.size();

  

  
  
  

    if (nData == 0) return;

  
  


    float x[nData];
    float y[nData];

  
    float dy[nData];





    if (nData != (int)median.size() || nData != (int)lower.size() || nData != (int)upper.size() )
    {
        cout << "bug in action1 at line 2042\n";



    } 

  
  



    for (int j = 0; j < nData; j++)
    {
        x[j] = bin[j];
        y[j] = median[j];
	dy[j] = 1.0;
    }

 




    cout << "Line 2852 nData=" << nData << endl;;
  

 

    for (unsigned long j = 0; j < median.size(); j++)
        y[j] = median[j];




  cout << "Line 2872\n";



    cbpgsci(2);
    cbpgline(nData, x, y);
    cbpgmtxt((char *)"T", -2.0, 0.0, 0.0, data->label1.c_str());
      
 

   
    for (int j = 0; j < (int)lower.size(); j++)
        y[j] = lower[j];
	
   
    cbpgsci(3);

     cbpgline(nData, x, y);
   
  
    cbpgmtxt((char *)"T", -3.0, 0.0, 0.0, data->label2.c_str() );
  
  
  cout << "Line 2893\n";


    for (int j = 0; j < (int)upper.size(); j++)
        y[j] = upper[j];

    cbpgsci(4);
   
    cbpgline(nData, x, y);
    cbpgmtxt((char *)"T", -4.0, 0.0, 0.0, data->label3.c_str() );

     cout << "Line 2904\n";

   
   

     //    delete [] x;
     //    delete [] y;



  cout << "Line 2914\n";



}

/**************************************************
 * Subroutine TransformMatrix
 * Sets up plotting transformation matrix.
 * Added by CB to prevent the code having to be
 * repeated twice in the main program
 * (as in original).
 ***************************************************/
float* TransformMatrix(float xmin, float xbinWidth, 
                      float ymin, float ybinWidth)
    
{
    float *trimage = new float[6];
 


   trimage[0] = xmin - xbinWidth / 2.0;
   //   trimage[0] = xmin;


    trimage[1] = xbinWidth;
    trimage[2] = 0.0;
    trimage[3] = ymin - ybinWidth / 2.0;

    //     trimage[3] = ymin;


    trimage[4] = 0.0;
    trimage[5] = ybinWidth;

    return trimage;
}

/************************************************************************
*
************************************************************************/
void loadDensity( float *a, int nx, int ny, 
                  float xmin, float xmax, 
                  float ymin, float ymax, 
                  vector<float> & xdata, vector<float> & ydata, int ndata)
{
    
    float dx = (xmax - xmin) / (float)(nx - 1);
    float dy = (ymax - ymin) / (float)(ny - 1);
   

    for (int i = 0; i < nx * ny; i++)
        a[i] = 0.0;



   

    float fMax = 0.0;
    for (int i = 0; i < ndata; i++)
    {
        if ( xdata[i] < xmin || xdata[i] > xmax ||
             ydata[i] < ymin || ydata[i] > ymax) continue;


	int k = (int)( (xdata[i] - xmin) / dx + 0.001);
	int l = (int)( (ydata[i] - ymin) / dy + 0.001);
 
        int n = l * ny + k;
        n = max(0, n);
        n = min(n, nx * ny - 1);



	a[n] += 1.0001;
	a[n] = (float)( (int)a[n]);
	fMax = max(fMax, a[n] );
    }

    cout << "Line 2741 fmax=" << fMax << endl;
    for (int i = 0; i < nx * ny; i++)
    	  a[i] /= fMax;


    cout << "loaddensity line 2812\n";


}
/******************************************************************
 * subroutine SetUpPalette
 * Set a "palette" of colors in the range of color indices used by
 * PGIMAG.
 *******************************************************************/
//void SetUpPalette(int type)
//{

//    float GL[] = { 0.0, 1.0};
//    float GR[] = { 0.0, 1.0};
//    float GG[] = { 0.0, 1.0};
//    float GB[] = { 0.0, 1.0};

//    float RL[] = {-0.5, 0.0, 0.17, 0.33, 0.50, 0.67, 0.83, 1.0, 1.7};
//    float RR[] = { 0.0, 0.0,  0.0,  0.0,  0.6,  1.0,  1.0, 1.0, 1.0};
//    float RG[] = { 0.0, 0.0,  0.0,  1.0,  1.0,  1.0,  0.6, 0.0, 1.0};
//    float RB[] = { 0.0, 0.3,  0.8,  1.0,  0.3,  0.0,  0.0, 0.0, 1.0};

//    float HL[] = { 0.0, 0.2, 0.4, 0.6, 1.0};
//    float HR[] = { 0.0, 0.5, 1.0, 1.0, 1.0};
//    float HG[] = { 0.0, 0.0, 0.5, 1.0, 1.0};
//    float HB[] = { 0.0, 0.0, 0.0, 0.3, 1.0};

//   float WL[] = { 0.0, 0.5, 0.5, 0.7, 0.7, 0.85, 0.85, 0.95, 0.95, 1.0};
//    float WR[] = { 0.0, 1.0, 0.0, 0.0, 0.3,  0.8,  0.3,  1.0,  1.0, 1.0};
//    float WG[] = { 0.0, 0.5, 0.4, 1.0, 0.0,  0.0,  0.2,  0.7,  1.0, 1.0};
//    float WB[] = { 0.0, 0.0, 0.0, 0.0, 0.4,  1.0,  0.0,  0.0, 0.95, 1.0};

//    float AL[] = { 0.0, 0.1, 0.1, 0.2, 0.2, 0.3, 0.3, 0.4, 0.4, 0.5, 
//                   0.5, 0.6, 0.6, 0.7, 0.7, 0.8, 0.8, 0.9, 0.9, 1.0};
//    float AR[] = { 0.0, 0.0, 0.3, 0.3, 0.5, 0.5, 0.0, 0.0, 0.0, 0.0, 
//                   0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0};
//    float AG[] = { 0.0, 0.0, 0.3, 0.3, 0.0, 0.0, 0.0, 0.0, 0.8, 0.8, 
//                   0.6, 0.6, 1.0, 1.0, 1.0, 1.0, 0.8, 0.8, 0.0, 0.0};
//    float AB[] = { 0.0, 0.0, 0.3, 0.3, 0.7, 0.7, 0.7, 0.7, 0.9, 0.9, 
//                   0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};

//    float TL[] = { 0.0, 0.5, 0.5, 1.0};
//    float TR[] = { 0.2, 0.6, 0.6, 1.0};
//    float TG[] = { 0.0, 0.0, 0.5, 1.0};
//    float TB[] = { 1.0, 0.0, 0.0, 0.0};

   
//    switch (type)
//    { 
//        case (1): //        -- gray scale

//	    cpgctab(GL, GR, GG, GB, 2, 1.0, 0.5);  // Were all 1.0, 0.5
//            break;
//	case (2): //        -- rainbow

//	    cpgctab(RL, RR, RG, RB, 9, 1.0, 0.5);
//	    break;
//	case (3): //        -- heat
//	    cpgctab(HL, HR, HG, HB, 5, 1.0, 0.5);
//            break; 

//	case (4): //        -- weird IRAF
//	    cpgctab(WL, WR, WG, WB, 10, 1.0, 0.5);
//            break;
//	case (5): //        -- AIPS
//	    cpgctab(AL, AR, AG, AB, 20, 1.0, 0.5);
//            break; 
//	case (6): //        -- TJP
//	    cpgctab(TL, TR, TG, TB, 4, 1.0, 0.5);
            
        
//    }

//}


/****************************************
! SetUpColourIndice
! Colour indices used to plot fits regions
!***************************************/
void SetUpColourIndices()
{

 

    cbpgscr(1,  0.0, 1.0, 1.0);                   // Cyan
    cbpgscr(2,  1.0, 0.0, 1.0);                   // Magenta
    cbpgscr(3,  1.0, 1.0, 0.0);                   // Yellow
    cbpgscr(4,  0.0, 128.0/255.0, 128.0/255.0);   // Dark cyan
    cbpgscr(5,  0.0, 0.0, 128.0/255.0);           // Dark blue
    cbpgscr(6,  128.0/255.0, 128.0/255.0, 0.0);   // Dark yellow
    cbpgscr(7,  0.0, 128.0/255.0, 0.0);           // Dark green
    cbpgscr(8,  128.0/255.0, 0.0, 128.0/255.0);   // Dark magenta
    cbpgscr(9,  128.0/255.0, 0.0, 0.0);           // Dark red

    
    cbpgscr(10, 0.0, 0.0, 0.0);               // Black
    
    cbpgscr(11, 1.0, 0.0, 0.0);                 // Red for background mask

}

/****************************************
! SetUpColourIndice
! Colour indices used to plot fits regions
!***************************************/
void SetUpDefaultColourIndices( )
{

 
    cbpgscr(1,  0.0, 0.0, 0.0);                   // black

    cbpgscr(2,  1.0, 0.0, 0.0);                   // red
    cbpgscr(3,  0.0, 0.0, 1.0);                   // blue
    cbpgscr(4,  0.0, 1.0, 0.0);                   // green

    cbpgscr(5,  204.0/255.0, 0.0, 1.0);                   // green


    //    cpgscr(5,  0.0, 1.0, 1.0);                   // Cyan
    cbpgscr(6,  1.0, 0.0, 1.0);                   // Magenta
    cbpgscr(7,  1.0, 1.0, 0.0);                   // Yellow
    cbpgscr(8,  0.0, 128.0/255.0, 128.0/255.0);   // Dark cyan
    cbpgscr(9,  0.0, 0.0, 128.0/255.0);           // Dark blue
    cbpgscr(10,  128.0/255.0, 128.0/255.0, 0.0);   // Dark yellow
    cbpgscr(11,  0.0, 128.0/255.0, 0.0);           // Dark green
    cbpgscr(12,  128.0/255.0, 0.0, 128.0/255.0);   // Dark magenta
    cbpgscr(13,   128.0/255.0, 0.0, 0.0);           // Dark red

    cbpgscr(14,   1.0, 1.0, 1.0);           // white


}



/****************************************************
*
*
****************************************************/
void convert(float xData, float ydata, float &x, float &y)
{
  
    float alpha2, delta, r2, f, cdec, denom;


    alpha2 = xData / (2.0 * radiansToDegrees);
    delta = ydata / radiansToDegrees;
    r2 = sqrt( 2.0 );
    f = 2.0 * r2 / M_PI;

    cdec = cos(delta);
    denom = sqrt(1.0 + cdec * cos(alpha2));

    x = cdec * sin(alpha2) * 2.0 * r2 / denom;
    y = sin(delta) * r2 / denom;

    x = x * radiansToDegrees / f;
    y = y * radiansToDegrees / f;

}
/*****************************************************
*
* Subroutine Histogram
* For one or more histograms
*
******************************************************/
void Histogram( vector< vector<float> >& data1, float binWidth,
                vector<string> &subTitle, 
		char *xLabel, 
                char *title, 
                float x1, float x2, 
                float xmin, float xmax, float dr)
{
        
    int noHists = data1.size(); // The number of histograms



    if (fabs(xmin - xmax) < 1e-6) {
        cout << "Unable to draw histogram- xmin=xmax\n";
        return;
    }

   
    xmin = floor( xmin );
    int noBins = int( (xmax - xmin) / binWidth + 0.0001 );
      
    if (noBins < 3) {
        cout << "omgraph- No of bins < 3\n";
        return;
    }
  
    float y1 = 0.1;
   

    int l = 1;










    for (int j = 0; j < noHists; j++) // Plot each histogram 
    {

       
        /******************************
        * Find the maximum bin size
        *******************************/
        int nData = data1[j].size();


	cout << "line 1565 ndata=" << nData << "subTitle=" << subTitle[j] << endl; 

        if( nData == 0 ) continue;


	cout << " line 1570 drawing histogram " << j << endl;
        float y11 = y1 + (float)(l - 1) * dr;
           
        float y12 = y1 + (float)(l) * dr;
        if (y12 > 0.9)
	{


            cbpgsch(0.8);

            cbpgmtxt((char *)"T", 1.0, 0.5, 0.5, title);



	    cbpgpage();


	    l = 1;
            y11 = y1;
            y12 = y1 + dr;

        }       


        vector<float> data = data1[j];

        // Sort the data
        sort( data.begin(), data.end() );

        int *frequency = new int[noBins];
        for (int i = 0; i < noBins; i++)
            frequency[i] = 0;

        int noLeft = 0, noRight = 0;


        for (int i = 0; i < nData; i++) 
        {


	  //	  cout << i << ") data=" << data[i] << endl;



            int k = int((data[i] - xmin) / binWidth + 0.00000001);       
            if (k <= 0)
	    {
	        noLeft++;
                
            }
            else if (k >= noBins)
	    {
	        noRight++;
                
             
            }
            else
                frequency[k - 1]++;
              
       
        }
    
  
        int maxFreq = MaxVal(frequency, noBins);
  

        float yMax1 = 0.0;
	float yMax = HistogramMaximum(maxFreq, nData, yMax1); 


        delete [] frequency;  
        
        cbpgsvp(x1, x2, y11, y12);

        cbpgswin(xmin, xmax, 0.0, yMax1);
 
        cbpgsci(1);     

        cbpgsch(1.0); 
        cbpgsfs(2);    
        cbpgslw(1);
        float *xData = new float[nData];
        for(int i = 0; i < nData; i++)
            xData[i] = data[i];


        cbpghist(nData, xData, xmin, xmax, noBins, 3);


        delete [] xData;
                     
        cbpgswin(xmin, xmax, 0.0, yMax);
    
        cbpgsch(1.0);  
 
        if (l == 1)    
	{
            cbpgbox((char *)"bctsi", binWidth, 5, (char *)"bctsi", 0.0, 0);
            cbpgbox((char *)"n", binWidth, 5, (char *)"n", 0.0, 0); 

   
        }
        else
	{
            cbpgbox((char *)"bc", binWidth, 0, (char *)"bctsi", 0.0, 0);
            cbpgbox((char *)"", binWidth, 0, (char *)"n", 0.0, 0); 
    
        }
     
    
        cbpgsch(0.8);
        cbpgslw(3);
 
  
        cbpglab((char *)"", (char *)"Frequency (%)", (char *)"");
        if (l == 1) 
            cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xLabel);

        cbpgslw(1);
        cbpgmtxt((char *)"T", -1, 0.5, 0.5, subTitle[j].c_str());

  
        char text[100];
   

        int k = 2;
        if (noLeft > 0)
        {
            sprintf( text, "No of data points < %.2f=%*d", xmin, (int(log10((float)noLeft) + 0.00001) + 1), noLeft);        
            cbpgsch(0.6);

            cbpgmtxt((char *)"T", -float(k), 0.0, 0.0, text);
            k++;
        }

        if (noRight> 0)
        {
            sprintf( text, "No of data points > %.2f=%d", xmax, noRight);        
            cbpgsch(0.6);

            cbpgmtxt((char *)"T", -float(k), 0.0, 0.0, text);
            k++;
        }




        // Get some statistics
        float mean = Mean( data );

        float median = Median( data );

        float p1 = Percentile( data, 0.05);
        float p2 = Percentile( data, 0.95);

        sprintf(text, "Mean=%.2f, Median=%.2f 0.05 percentile=%.2f, 0.95=%.2f, N=%d", mean, median, p1, p2, nData);
        sprintf(text, "Mean=%.2f, Median=%.2f, N=%d", mean, median, nData);

        cbpgsch(1.0);

        cbpgmtxt((char *)"T", -float(k), 0.0, 0.0, text);
     
        l++; 


    }  // End of this histogram
   
    cbpgsch(0.8);

    cbpgmtxt((char *)"T", 1.0, 0.5, 0.5, title);

}
/*****************************************************
*
*
* Subroutine Histogram
*
*
******************************************************/

void Histogram1( vector<int16> & data, int16 binWidth1, 
                char *xLabel, char *title, 
                float x1, float x2, float y1, float y2, 
                int16 xmin1, int16 xmax1)

{


  //   cout << "HISTOGRAM line 3059 binwidth=" << (int)binWidth1 << endl;

    
    double binWidth = (double)binWidth1;
    if(xmax1 < xmin1) binWidth = -binWidth;

    double xmin = double(xmin1);
    double xmax = double(xmax1);
  

    // cout << "xmin=" << xmin << " xmax=" << xmax << " binwidth=" << binWidth << endl;



    /****************************************************
    * 
    *
    *****************************************************/
    if( (xmin == 0.0 && xmax == 0.0) || (abs(xmax) - abs(xmin)) < 1e-9) 
    {

        int noLeftBins = int(abs(xmin) / binWidth + 0.000000001);
        xmin = -(double(noLeftBins) * binWidth + binWidth / 2.0);
        int noRightBins = int(xmax / binWidth + 0.000000001);
        xmax = double(noRightBins) * binWidth + binWidth / 2.0;


    }




    //   cout << "Line 839 xmin=" << xmin << " xmax=" << xmax << " binwidth=" << binWidth << endl;


    
    int nData = data.size(); 



    // cout << "HISTOGRAM line 3099 binwidth=" << binWidth1 << endl;


    // Sort the data
    sort( data.begin(), data.end() );

    if (fabs(xmin - xmax) < 1e-20) {
        cout << "Unable to draw histogram- xmin=xmax\n";
        return;
    }

   
 
    int noBins = int( (xmax - xmin) / binWidth + 0.0001 );
    
  
    if (noBins == 0) {
        cout << "omgraph- No of bins < 3\n";
        return;
    }
  
    
    //  cout << "HISTOGRAM line 3127 nobins=" << noBins << " xmin=" << xmin << " xmax=" << xmax << endl;



    /******************************
    *
    * Find the maximum bin size
    *******************************/

    int *frequency = new int[noBins];
    float *bin = new float[noBins];
    float *height = new float[noBins];

    for (int i = 0; i < noBins; i++)
    {
        frequency[i] = 0;
        bin[i] = xmin + binWidth * double(i) + binWidth / 2.0;
    }

 
    int noLeft = 0, noRight = 0;

    // cout << "Line 3149 noBins=" << noBins << " binwidth=" << binWidth << endl;

    for (int i = 0; i < nData; i++) 
    {
        int k = int( abs(data[i] - xmin) / binWidth + 0.00000001);       
        if (k < 0)
	{

	  //  cout << i << ") data=" << data[i] << " noleft=" << noLeft << " xmin=" << xmin << " binwidth=" << binWidth << endl; 
	    noLeft++;
            k = 0;
        }
        else if (k >= noBins)
	{
	    noRight++;
            k = noBins - 1;
        }
        frequency[k]++;
       
    }
    for(int i = 0; i < noBins; i++)
      height[i] = float(frequency[i] );
  


  

    int maxFreq =  MaxVal(frequency, noBins);
  
    float yMax = min(nData, (int)( float(maxFreq) * 1.50)); 


    //cout << "Line 3181 maxfreq=" << maxFreq << " ymax=" << yMax << endl;


    
    cbpgsvp(x1, x2, y1, y2);


    cbpgswin(xmin, xmax, 0.0, yMax);
         

    cbpgsci(1);     

    cbpgsch(1.0); 
    cbpgsfs(2);    
    cbpgslw(1);
    float *xData = new float[nData];
    for(int i = 0; i < nData; i++)
        xData[i] = data[i];





    //cout << "HISTOGRAM line 3204 nobins=" << noBins << endl;






    if(noBins >= 100 || MinVal(frequency, noBins) > max(100, nData / noBins) )    
    {
        cbpgline(noBins, bin, height);
    }
    else
    {

      // cout << "calling pghist xmin=" << xmin << " xmax=" << xmax << " nobins=" << noBins << endl;
        cbpghist(nData, xData, (float)xmin, (float)xmax, noBins, 3);
    }



    delete [] frequency;  
    delete [] bin;
    delete [] height;

    delete [] xData;


    cbpgswin((float)xmin, (float)xmax, 0.0, (yMax / float(nData)) * 100.0);

     
    cbpgsch(0.8);  

    if(noBins > getMaxNoBins())
    {
        for(int i = 0; i < 10; i++)
        {
            noBins = int( (xmax - xmin) / binWidth + 0.0001 );

            if(noBins > getMaxNoBins() ) 
                binWidth *= 2.0;
            else
	        break;
    
        }
    } 







    //   binWidth = ( xmax - xmin ) / (double)getMaxNoBins();
    
  
    binWidth = abs(binWidth);

    cbpgbox((char *)"bctsi", binWidth, 5, (char *)"bctsi", 0.0, 0);

    cbpgsch(1.0);  
    cbpgbox((char *)"n", binWidth, 5, (char *)"n", 0.0, 0); 


    cbpgsch(0.9);  
    char text[100];
    int k = 1;

    if (noLeft > 0)
    {
        sprintf( text, "No of data points < %.2f=%*d", xmin, (int(log10((float)noLeft) + 0.00001) + 1), noLeft);        
        cbpgmtxt((char *)"T", -float(k), 0.0, 0.0, text);
        k++;
    }

    if (noRight> 0)
    {
        sprintf( text, "No of data points > %.2f=%d", xmax, noRight);        
        cbpgmtxt((char *)"T", -float(k), 0.0, 0.0, text);
        k++;
    }


 


    sort(data.begin(), data.end());


    // Get some statistics
    double mean = Mean(data);


    double median = Median(data);;
    double std = 0.0; 

    double mode = halfRangeMode( data, mean, std, median);

    double p1 = Percentile(data, 0.05);

    double p2 = Percentile(data, 0.95);




    sprintf(text, "Mean=%.2f, Median=%d, mode=%d, 0.05 percentile=%d, 0.95=%d", mean, (int)median, (int)mode, (int)p1, (int)p2);
 

    cbpgsch(1.0);  
  
    cbpgmtxt((char *)"T", -float(k), 0.0, 0.0, text);
 


    cbpgsch(1.5);

    char yLabel[100];

    sprintf( yLabel, "%s %d %s", "FREQUENCY (%) (TOTAL=", nData, ")" );
       
    cbpgslw(3);
 
    cbpglab((char *)" ", yLabel, title);
    
    cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xLabel);
    cbpgslw(1);
 
   
    cbpgswin(xmin, xmax, 0.0, yMax);
 


}









