module omsortra_mod

  use dal
  use sasdal
 

  use errorHandling
  
  use omallocation_mod 

  use omutility_mod
  use omnumerics_mod
public
contains

!*************************************************************************
!
!
!*************************************************************************
subroutine sortTable( tableH )
  

    type(tableT), intent(inout) :: tableH
    integer :: nRows, i, k
    real(double), pointer, dimension(:) :: ra=> null()
    integer, pointer :: raSortIndex(:) => null()

  




    nRows = numberOfRows( tableH )



    if(nrows < 2) then
        return
    end if

   



    raSortIndex => allocateInt32(1, nRows, "raSortindex")

    !**********************************************************
    ! 
    !
    !*********************************************************

    ra => allocateDouble(1, nRows, "ra")



    if(hasColumn(tableH, "RA_CORR") ) then
!        write(*, *) "Reading column ra_corr"
        call ReadReal64Column(tableH, "RA_CORR", nrows, 0, ra)
    else
        call ReadReal64Column(tableH, "RA", nrows, 0, ra)
    end if

    !*****************************************************
    ! Find the order of increasing  RA- store in RASortIndex
    ! for adding data to source list table in  
    ! increasing RA order (ra is not sorted)
    !****************************************************
    call IndexSort(ra, RASortIndex, nRows)


    call insertrows( tableH, nRows,  nRows )
    call copyRows( tableH, 0, nRows, nRows)

    !*************************************************************
    ! Reorder the table into increasing RA order
    !*************************************************************
    do i = 0, nRows - 1
        k = raSortIndex(i + 1) + nrows - 1       
      
        call copyRows( tableH, k, i, 1)
    end do

    call deleteRows( tableH, nrows, nrows)

   
    deallocate(ra, rasortIndex)


end subroutine sortTable

end module omsortra_mod
