module interpolate_mod
use dal
use sla
use cubicshepard_mod
public


type(structShepard), private, save :: shepard(10)
contains
subroutine initialiseshepard(n, x, y, f, shepNo, minSep)
    integer, intent(in) :: n
    real(double), dimension(1 : n) :: x, y, f
    integer, intent(in) :: shepNo
    real(double), intent(in) :: minSep
    integer :: i

    write(*, *) 

!    do i = 1, n
!        write(*, *) i, ") x=", x(i), " y=", y(i), " f=", f(i)
!    end do


    call shepardConstruct(shepard(shepNo), n, x, y, f, minSep)

 

end subroutine initialiseshepard
!***************************************************************
!
!
!**************************************************************/
real(double) function shepinterpolate(x, y, shepNo)
    real(double), intent(in) :: x, y
    integer, intent(in) :: shepNo
    shepinterpolate = ShepardInterpolate(shepard(shepNo), x, y)

end function shepinterpolate
 






end module interpolate_mod
