#include "utility.h"
#include <string>
#include <cmath>
#include<vector>
#include<numeric>
#include <iostream>









/**************************************************************
*
*
***************************************************************/

bool isNull(int8 value)
{  

    if( value == 127)
      return true;
    else
    return false;    

}
bool isNull(int16 value)
{  

    if( value == 32767)
      return true;
    else
    return false;    

}

bool isNull(int32 value)
{  

       
    stringstream ss;
    ss << value;
    string text = ss.str();
 
        
    if ( (int)text.find("nan") >= 0) return true;
    if ( (int)text.find("NAN") >= 0) return true;
    if ( (int)text.find("null") >= 0) return true;
    if ( (int)text.find("NULL") >= 0) return true;

    return false;    


}




bool isNull( float value)
{  



    stringstream ss;
    ss << value;
    string text = ss.str();
 


        
    if ( (int)text.find("nan") >= 0) return true;
    if ( (int)text.find("NAN") >= 0) return true;
    if ( (int)text.find("null") >= 0) return true;
    if ( (int)text.find("NULL") >= 0) return true;

    return false;    

};

bool isNull( double value)
{  

   
    stringstream ss;
    ss << value;
    string text = ss.str();
    
    if ( (int)text.find("nan") >= 0) return true;
    if ( (int)text.find("NAN") >= 0) return true;
    if ( (int)text.find("null") >= 0) return true;
    if ( (int)text.find("NULL") >= 0) return true;

    return false;    

};

bool isNull( char * value)
{  

    stringstream ss;
    ss << value;
    string text = ss.str();
         
    if ( (int)text.find("nan") >= 0) return true;
    if ( (int)text.find("NAN") >= 0) return true;
    if ( (int)text.find("null") >= 0) return true;
    if ( (int)text.find("NULL") >= 0) return true;

    return false;    

};















//bool isNullInt8( int8 value)
//{  
//   if ( (int)value == 127) 
     
//       return true;
//   else
//       return false;    

//};



/*******************************************************************
*
*******************************************************************/
double distance(double r1, double d1, double r2, double d2)
{



    return acos( sin(d1) * sin(d2) + cos(d1) * cos(d2) 
	            * cos(r1 - r2) ) * radiansToArcSecs; 


};
/*************************************************************************
*
***************************************************************************/
double Error(double dx, double dy)
{
  if (dx > dy)
    return dx * sqrt(1.0 + (dy / dx) * (dy / dx));
  else
    return dy * sqrt(1.0 + (dx / dy) * (dx / dy));
} 

/***************************************************************
*
*
****************************************************************/
float Median(vector<float> &data)
{

    



    float median;
    int nData = data.size();

    if (nData == 0) return 0.0;
    if (nData == 1) return data[0]; 

    int n2 = nData / 2;

    if ( n2 * 2 == nData ) // Even number of points
        median = (data[n2 - 1] + data[n2]) / 2.0;
    else
      median = data[n2];

    return median;
}    

/***************************************************************
*
*
****************************************************************/
double Median(vector<double> &data)
{
    double median;
    int nData = data.size();

    if (nData == 0) return 0.0;
    if (nData == 1) return data[0]; 

    int n2 = nData / 2;

    if ( n2 * 2 == nData ) // Even number of points
        median = (data[n2 - 1] + data[n2]) / 2.0;
    else
      median = data[n2];

    return median;
}    





/***************************************************************
*
*
****************************************************************/
float Mean(float *data, long nData)
{

    double mean = 0.0;
    if (nData == 0) return 0.0;

    for( long i = 0; i < nData; i++)
        mean += (double)data[i];

    return (float)(mean / (double)nData);

}


/***************************************************************
*
*
****************************************************************/
double Mean(double *data, long nData)
{

    double mean = 0.0;
    if (nData == 0) return 0.0;

    for( long i = 0; i < nData; i++)
        mean += (double)data[i];

    return (float)(mean / (double)nData);

}






/***************************************************************
*
*
****************************************************************/
float Mean(vector<float> &data)
{
    if (data.size() == 0) return 0.0;


    return (float)(accumulate( data.begin(), data.end(), 0.0 ) / double(data.size() ));


}


/***************************************************************
*
*
****************************************************************/
double Mean(vector<double> &data)
{
    if (data.size() == 0) return 0.0;


    return (float)(accumulate( data.begin(), data.end(), 0.0 ) / double(data.size() ));


}





/***************************************************************
*
*
****************************************************************/
float Median(float *data, long nData)
	{
    float median;


    if (nData == 0) return 0.0;
    if (nData == 1) return data[0]; 



  
    int n2 = nData / 2;

    if ( n2 * 2 == nData ) // Even number of points
        median = (data[n2 - 1] + data[n2]) / 2.0;
    else
      median = data[n2];

    return median;
}    


/***************************************************************
*
*
****************************************************************/
double Median(double *data, long nData)
	{
    double median;


    if (nData == 0) return 0.0;
    if (nData == 1) return data[0]; 



  
    int n2 = nData / 2;

    if ( n2 * 2 == nData ) // Even number of points
        median = (data[n2 - 1] + data[n2]) / 2.0;
    else
      median = data[n2];

    return median;
}    







/***************************************************************
*
*
****************************************************************/
float Percentile(vector<float> &data, float perCent)
{

    long size = data.size();
    
    long index = (long)(perCent * (float)size + 0.00001) - 1;
    index = max((long)0, index);
    index = min(index, size - 1); 
     
    cout << "n=" << size << " percent=" << perCent << " index=" << index << " percentile=" << data[index] << endl;
    cout << "data[0]=" << data[0] << " data[" << (size - 1) << "]" << data[size - 1] << endl;
    return data[index];

}


/***************************************************************
*
*
****************************************************************/
double Percentile(vector<double> &data, float perCent)
{

    long size = data.size();
    
    long index = (long)(perCent * (float)size + 0.00001) - 1;
    index = max((long)0, index);
    index = min(index, size - 1); 
     
    cout << "n=" << size << " percent=" << perCent << " index=" << index << " percentile=" << data[index] << endl;
    cout << "data[0]=" << data[0] << " data[" << (size - 1) << "]" << data[size - 1] << endl;
    return data[index];

}







/***************************************************************
*
*
****************************************************************/
float Percentile(float *data, long size, float perCent)
{

 
    
    long index = (long)(perCent * (float)size + 0.00001) - 1;
    index = max((long)0, index);
    index = min(index, size - 1); 

    return data[index];

}


/***************************************************************
*
*
****************************************************************/
double Percentile(double *data, long size, float perCent)
{

 
    
    long index = (long)(perCent * (float)size + 0.00001) - 1;
    index = max((long)0, index);
    index = min(index, size - 1); 

    return data[index];

}

